> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.propexo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.propexo.com/_mcp/server.

# Get all resident charges

GET https://api.propexo.com/v1/resident-charges/

The Resident Charges model provides a limited, one-sided view of a resident's financial history with a PMC and should not be treated as a comprehensive report of all charges that the resident owes. Credits to a resident's ledger are stored as negative charges. Due to the PMS API structure, this is a naturally high-volume endpoint. Since Propexo pricing is based on records returned, this may result in signficantly higher overall costs. We encourage you to reach out to support before activating.

Reference: https://docs.propexo.com/api-reference/propertyware-rest/billing-and-payments/get-all-resident-charges

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.propexo.com` (Production, default)
- `https://api.sandbox.propexo.com` (Sandbox)

## Request

### Query parameters

- `order-by` (string, optional, default: created_at:desc) — Order the results by a field. Optionally include asc or desc preceded by a colon (default is asc). Example: ?order-by=updated_at:desc
- `updated_at_gte` (string, optional, nullable) — Filter to records updated at or after this datetime. Format: ISO 8601 (e.g. 2026-01-01T00:00:00Z)
- `updated_at_lte` (string, optional, nullable) — Filter to records updated at or before this datetime. Format: ISO 8601 (e.g. 2026-12-31T23:59:59Z)
- `last_seen_gte` (string, optional, nullable) — Filter to records whose last_seen date is on or after this datetime. Format: ISO 8601 (e.g. 2026-01-01T00:00:00Z)
- `last_seen_lte` (string, optional, nullable) — Filter to records whose last_seen date is on or before this datetime. Format: ISO 8601 (e.g. 2026-12-31T23:59:59Z)
- `offset` (integer, optional, nullable, default: 0) — Can be used for paginating results
- `limit` (integer, optional, nullable, default: 100) — A number between 1 and 250 to determine the number of results to return in a single query
- `property_id` (string, optional) — The Propexo unique identifier for the property
- `integration_id` (string, optional) — The Propexo unique identifier for the integration
- `integration_vendor` (enum, optional) — The property management system of record
  - Allowed values: `APPFOLIO`, `BUILDIUM`, `ENTRATA`, `MRI`, `PROPERTYWARE`, `PROPERTYWARE_REST`, `REALPAGE`, `REALPAGE_RPX`, `RENTMANAGER`, `RENTVINE`, `RESMAN`, `YARDI`, `YARDI_REST`
- `resident_id` (string, optional) — The Propexo unique identifier for the resident
- `lease_id` (string, optional) — The Propexo unique identifier for the lease
- `transaction_date_start` (string, optional, nullable) — The start of the transaction date range to search. Inclusive.
- `transaction_date_end` (string, optional, nullable) — The end of the transaction date range to search. Inclusive.

## Response

### 200

Successful response

- `meta` (ResponseMeta, required)
- `results` (list of ResidentCharge, required)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (ErrorResponseError, required)

## Types

### ResponseMeta

- `orderBy` (list of ResponseMetaOrderByItems, required) — The order of the results
- `offset` (integer, optional) — The offset of the first result
- `limit` (integer, optional) — The number of results to return
- `hasMore` (boolean, optional, nullable) — Whether there are more results
- `total` (integer, optional) — The total number of results

### ResidentCharge

- `id` (string, required) — The Propexo unique identifier for the resident charge
- `created_at` (string, required) — The date record first entered Propexo
- `updated_at` (string, required) — The date record was last updated in Propexo
- `last_seen` (string, required, nullable) — The date the record was last seen from the PMS
- `x_id` (string, required) — The external ID from the integration vendor | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `x_property_id` (string, required) — The external ID of the property from the integration vendor | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `x_gl_account_id` (string, required, nullable) — The external ID of the general ledger account from the integration vendor | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `x_location_id` (any, required) — The external ID of the location (exclusive to Rent Manager integrations). This is always null for non-Rent Manager integrations.This field will always be null for PROPERTYWARE\_REST
- `x_lease_id` (string, required, nullable) — The external ID of the lease from the integration vendor | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `x_resident_id` (any, required) — The external ID of the resident from the integration vendorThis field will always be null for PROPERTYWARE\_REST
- `x_unit_id` (string, required, nullable) — The external ID of the unit from the integration vendor | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `x_charge_code_id` (any, required) — The external ID of the charge code from the integration vendorThis field will always be null for PROPERTYWARE\_REST
- `amount_in_cents` (double, required, nullable) — The amount of the resident charge, in cents | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `amount_raw` (string, required, nullable) — The raw value for amount from the PMS | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `amount_open_in_cents` (any, required) — The amount open on the resident charge, in centsThis field will always be null for PROPERTYWARE\_REST
- `amount_open_raw` (any, required) — The raw value for open amount from the PMSThis field will always be null for PROPERTYWARE\_REST
- `amount_paid_in_cents` (double, required, nullable) — The amount paid on the resident charge, in cents | Method | Interface | |---|---| | /v1/leases/charges | Leases |
- `amount_paid_raw` (string, required, nullable) — The raw value for amount paid from the PMS | Method | Interface | |---|---| | /v1/leases/charges | Leases |
- `due_date` (any, required) — The due date associated with the resident chargeThis field will always be null for PROPERTYWARE\_REST
- `name` (string, required, nullable) — The name associated with the resident charge | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `description` (string, required, nullable) — Description of the resident charge | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `reference_number` (string, required, nullable) — The reference number for the resident charge | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `transaction_date` (string, required, nullable) — The transaction date of the resident charge | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `transaction_source` (any, required) — The transaction source of the resident chargeThis field will always be null for PROPERTYWARE\_REST
- `is_open` (any, required) — Whether the resident charge is open and not yet settledThis field will always be null for PROPERTYWARE\_REST
- `post_month` (any, required) — The post month for the resident chargeThis field will always be null for PROPERTYWARE\_REST
- `custom_data` (ResidentChargeCustomData, required, nullable)
- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `integration_vendor` (enum, required) — The property management system of record
  - Allowed values: `PROPERTYWARE_REST`, `APPFOLIO`, `BUILDIUM`, `ENTRATA`, `MRI`, `PROPERTYWARE`, `REALPAGE`, `REALPAGE_RPX`, `RENTMANAGER`, `RENTVINE`, `RESMAN`, `YARDI`, `YARDI_REST`
- `property_id` (string, required) — The Propexo unique identifier for the property
- `resident_id` (any, required) — The Propexo unique identifier for the residentThis field will always be null for PROPERTYWARE\_REST
- `financial_account_id` (string, required, nullable) — The Propexo unique identifier for the financial account | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `unit_id` (any, required) — The Propexo unique identifier for the unitThis field will always be null for PROPERTYWARE\_REST
- `lease_id` (string, required, nullable) — The Propexo unique identifier for the lease | Method | Interface | |---|---| | /v1/leases/charges | Leases | | /v1/leases/discounts | Leases |
- `charge_code_id` (any, required) — The Propexo unique identifier for the charge codeThis field will always be null for PROPERTYWARE\_REST
- `allocations` (list of ResidentChargeAllocationsItems, required) — Array of payment allocations, splits, and related transactions associated with the resident charge

### ErrorResponseError

- `code` (string, required)
- `message` (string, required)
- `details` (map from string to any, optional)

### ResponseMetaOrderByItems

### ResidentChargeCustomData

### ResidentChargeAllocationsItems

- `id` (string, required) — The Propexo unique identifier for the resident allocation
- `x_id` (string, required) — The external ID from the integration vendor | Method | Interface | |---|---| | /v1/accounting/generalledger | Accounting |
- `x_source_id` (string, required, nullable) — The external ID of the source transaction from the integration vendor | Method | Interface | |---|---| | /v1/accounting/generalledger | Accounting |
- `x_destination_id` (string, required, nullable) — The external ID of the destination transaction from the integration vendor | Method | Interface | |---|---| | /v1/accounting/generalledger | Accounting |
- `financial_account_id` (string, required, nullable) — The Propexo unique identifier for the financial account | Method | Interface | |---|---| | /v1/accounting/generalledger | Accounting |
- `amount_in_cents` (double, required, nullable) — The amount of the resident allocation, in cents | Method | Interface | |---|---| | /v1/accounting/generalledger | Accounting |
- `amount_raw` (string, required, nullable) — The raw value for amount from the PMS | Method | Interface | |---|---| | /v1/accounting/generalledger | Accounting |
- `resident_charge_id` (string, required, nullable) — The Propexo unique identifier for the resident chargeThis field is not currently hydrated for PROPERTYWARE\_REST
- `resident_payment_id` (string, required, nullable) — The Propexo unique identifier for the resident paymentThis field is not currently hydrated for PROPERTYWARE\_REST
- `created_at` (string, required) — The date record first entered Propexo
- `updated_at` (string, required) — The date record was last updated in Propexo
- `last_seen` (string, required, nullable) — The date the record was last seen from the PMS
- `custom_data` (ResidentChargeAllocationsItemsCustomData, required, nullable)

### ResidentChargeAllocationsItemsCustomData

## Examples

**Response**

```json
{
  "meta": {
    "orderBy": [
      {}
    ],
    "offset": 0,
    "limit": 100,
    "hasMore": true,
    "total": 1000
  },
  "results": [
    {
      "id": "clwktsp9v000008l31iv218hn",
      "created_at": "2024-03-21T15:38:08.337Z",
      "updated_at": "2024-03-22T10:59:45.119Z",
      "last_seen": "2024-03-22T10:59:45.119Z",
      "x_id": "4328822592",
      "x_property_id": "2951884752",
      "x_gl_account_id": "1522786622",
      "x_location_id": null,
      "x_lease_id": "3307510985",
      "x_resident_id": null,
      "x_unit_id": "63520982",
      "x_charge_code_id": null,
      "amount_in_cents": 150000,
      "amount_raw": "1500",
      "amount_open_in_cents": null,
      "amount_open_raw": null,
      "amount_paid_in_cents": 130000,
      "amount_paid_raw": "1300",
      "due_date": null,
      "name": "CHARGE",
      "description": "Special cleaning fee",
      "reference_number": "565112",
      "transaction_date": "2023-04-21",
      "transaction_source": null,
      "is_open": null,
      "post_month": null,
      "custom_data": {},
      "integration_id": "clwh5u07w000508me66sfh3um",
      "integration_vendor": "PROPERTYWARE_REST",
      "property_id": "clwi5xiix000008l6ctdgafyh",
      "resident_id": null,
      "financial_account_id": "cav6ubr70d001b1ri112pi5it",
      "unit_id": null,
      "lease_id": "cm70kirrr29460295341h2g0bn44mxca",
      "charge_code_id": null,
      "allocations": [
        {
          "id": "clwktsp9v000008l31iv218hn",
          "x_id": "5738100275-8635281836",
          "x_source_id": "574622569",
          "x_destination_id": "573829483",
          "financial_account_id": "cm1b8bftm000208l485ya3klj",
          "amount_in_cents": 20000,
          "amount_raw": "200",
          "resident_charge_id": "string",
          "resident_payment_id": "string",
          "created_at": "2024-03-21T15:38:08.337Z",
          "updated_at": "2024-03-22T10:59:45.119Z",
          "last_seen": "2024-03-22T10:59:45.119Z",
          "custom_data": {}
        }
      ]
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.propexo.com/v1/resident-charges/"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.propexo.com/v1/resident-charges/';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.propexo.com/v1/resident-charges/"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.propexo.com/v1/resident-charges/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.propexo.com/v1/resident-charges/")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.propexo.com/v1/resident-charges/', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.propexo.com/v1/resident-charges/");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.propexo.com/v1/resident-charges/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```